Index: palm/trunk/SOURCE/surface_mod.f90
===================================================================
--- palm/trunk/SOURCE/surface_mod.f90	(revision 4670)
+++ palm/trunk/SOURCE/surface_mod.f90	(revision 4671)
@@ -3138,125 +3173,125 @@
              ENDDO
 
-             IF ( l == 0 )  THEN
-                DO  m = surf_lsm_h%start_index(j,i), surf_lsm_h%end_index(j,i)
-                   IF ( ALLOCATED( surf_lsm_h%us ) )  surf_h(0)%us(mm(0)) = surf_lsm_h%us(m)
-                   IF ( ALLOCATED( surf_lsm_h%ts ) )  surf_h(0)%ts(mm(0)) = surf_lsm_h%ts(m)
-                   IF ( ALLOCATED( surf_lsm_h%qs ) )  surf_h(0)%qs(mm(0)) = surf_lsm_h%qs(m)
-                   IF ( ALLOCATED( surf_lsm_h%ss ) )  surf_h(0)%ss(mm(0)) = surf_lsm_h%ss(m)
-                   IF ( ALLOCATED( surf_lsm_h%qcs ) )  surf_h(0)%qcs(mm(0)) = surf_lsm_h%qcs(m)
-                   IF ( ALLOCATED( surf_lsm_h%ncs ) )  surf_h(0)%ncs(mm(0)) = surf_lsm_h%ncs(m)
-                   IF ( ALLOCATED( surf_lsm_h%qis ) )  surf_h(0)%qis(mm(0)) = surf_lsm_h%qis(m)
-                   IF ( ALLOCATED( surf_lsm_h%nis ) )  surf_h(0)%nis(mm(0)) = surf_lsm_h%nis(m)
-                   IF ( ALLOCATED( surf_lsm_h%qrs ) )  surf_h(0)%qrs(mm(0)) = surf_lsm_h%qrs(m)
-                   IF ( ALLOCATED( surf_lsm_h%nrs ) )  surf_h(0)%nrs(mm(0)) = surf_lsm_h%nrs(m)
-                   IF ( ALLOCATED( surf_lsm_h%ol ) )  surf_h(0)%ol(mm(0)) = surf_lsm_h%ol(m)
-                   IF ( ALLOCATED( surf_lsm_h%rib ) )  surf_h(0)%rib(mm(0)) = surf_lsm_h%rib(m)
-                   IF ( ALLOCATED( surf_lsm_h%pt_surface ) )                                       &
-                      surf_h(l)%pt_surface(mm(l)) = surf_lsm_h%pt_surface(m)
-                   IF ( ALLOCATED( surf_def_h(l)%q_surface ) )                                     &
-                      surf_h(l)%q_surface(mm(l)) = surf_lsm_h%q_surface(m)
-                   IF ( ALLOCATED( surf_def_h(l)%vpt_surface ) )                                   &
-                      surf_h(l)%vpt_surface(mm(l)) = surf_lsm_h%vpt_surface(m)
-                   IF ( ALLOCATED( surf_lsm_h%usws ) )  surf_h(0)%usws(mm(0)) = surf_lsm_h%usws(m)
-                   IF ( ALLOCATED( surf_lsm_h%vsws ) )  surf_h(0)%vsws(mm(0)) = surf_lsm_h%vsws(m)
-                   IF ( ALLOCATED( surf_lsm_h%shf ) )  surf_h(0)%shf(mm(0)) = surf_lsm_h%shf(m)
-                   IF ( ALLOCATED( surf_lsm_h%qsws ) )  surf_h(0)%qsws(mm(0)) = surf_lsm_h%qsws(m)
-                   IF ( ALLOCATED( surf_lsm_h%ssws ) )  surf_h(0)%ssws(mm(0)) = surf_lsm_h%ssws(m)
-                   IF ( ALLOCATED( surf_lsm_h%css ) )  THEN
+             IF ( l < 2 )  THEN
+                DO  m = surf_lsm_h(l)%start_index(j,i), surf_lsm_h(l)%end_index(j,i)
+                   IF ( ALLOCATED( surf_lsm_h(l)%us ) )  surf_h(0)%us(mm(0)) = surf_lsm_h(l)%us(m)
+                   IF ( ALLOCATED( surf_lsm_h(l)%ts ) )  surf_h(0)%ts(mm(0)) = surf_lsm_h(l)%ts(m)
+                   IF ( ALLOCATED( surf_lsm_h(l)%qs ) )  surf_h(0)%qs(mm(0)) = surf_lsm_h(l)%qs(m)
+                   IF ( ALLOCATED( surf_lsm_h(l)%ss ) )  surf_h(0)%ss(mm(0)) = surf_lsm_h(l)%ss(m)
+                   IF ( ALLOCATED( surf_lsm_h(l)%qcs ) )  surf_h(0)%qcs(mm(0)) = surf_lsm_h(l)%qcs(m)
+                   IF ( ALLOCATED( surf_lsm_h(l)%ncs ) )  surf_h(0)%ncs(mm(0)) = surf_lsm_h(l)%ncs(m)
+                   IF ( ALLOCATED( surf_lsm_h(l)%qis ) )  surf_h(0)%qis(mm(0)) = surf_lsm_h(l)%qis(m)
+                   IF ( ALLOCATED( surf_lsm_h(l)%nis ) )  surf_h(0)%nis(mm(0)) = surf_lsm_h(l)%nis(m)
+                   IF ( ALLOCATED( surf_lsm_h(l)%qrs ) )  surf_h(0)%qrs(mm(0)) = surf_lsm_h(l)%qrs(m)
+                   IF ( ALLOCATED( surf_lsm_h(l)%nrs ) )  surf_h(0)%nrs(mm(0)) = surf_lsm_h(l)%nrs(m)
+                   IF ( ALLOCATED( surf_lsm_h(l)%ol ) )  surf_h(0)%ol(mm(0)) = surf_lsm_h(l)%ol(m)
+                   IF ( ALLOCATED( surf_lsm_h(l)%rib ) )  surf_h(0)%rib(mm(0)) = surf_lsm_h(l)%rib(m)
+                   IF ( ALLOCATED( surf_lsm_h(l)%pt_surface ) )                                       &
+                      surf_h(l)%pt_surface(mm(l)) = surf_lsm_h(l)%pt_surface(m)
+                   IF ( ALLOCATED( surf_def_h(l)%q_surface ) )                                        &
+                      surf_h(l)%q_surface(mm(l)) = surf_lsm_h(l)%q_surface(m)
+                   IF ( ALLOCATED( surf_def_h(l)%vpt_surface ) )                                      &
+                      surf_h(l)%vpt_surface(mm(l)) = surf_lsm_h(l)%vpt_surface(m)
+                   IF ( ALLOCATED( surf_lsm_h(l)%usws ) )  surf_h(0)%usws(mm(0)) = surf_lsm_h(l)%usws(m)
+                   IF ( ALLOCATED( surf_lsm_h(l)%vsws ) )  surf_h(0)%vsws(mm(0)) = surf_lsm_h(l)%vsws(m)
+                   IF ( ALLOCATED( surf_lsm_h(l)%shf ) )  surf_h(0)%shf(mm(0)) = surf_lsm_h(l)%shf(m)
+                   IF ( ALLOCATED( surf_lsm_h(l)%qsws ) )  surf_h(0)%qsws(mm(0)) = surf_lsm_h(l)%qsws(m)
+                   IF ( ALLOCATED( surf_lsm_h(l)%ssws ) )  surf_h(0)%ssws(mm(0)) = surf_lsm_h(l)%ssws(m)
+                   IF ( ALLOCATED( surf_lsm_h(l)%css ) )  THEN
                       DO  lsp = 1, nvar
-                         surf_h(0)%css(lsp,mm(0)) = surf_lsm_h%css(lsp,m)
+                         surf_h(0)%css(lsp,mm(0)) = surf_lsm_h(l)%css(lsp,m)
                       ENDDO
                    ENDIF
-                   IF ( ALLOCATED( surf_lsm_h%cssws ) )  THEN
+                   IF ( ALLOCATED( surf_lsm_h(l)%cssws ) )  THEN
                       DO  lsp = 1, nvar
-                         surf_h(0)%cssws(lsp,mm(0)) = surf_lsm_h%cssws(lsp,m)
+                         surf_h(0)%cssws(lsp,mm(0)) = surf_lsm_h(l)%cssws(lsp,m)
                       ENDDO
                    ENDIF
-                   IF ( ALLOCATED( surf_lsm_h%qcsws ) )                                            &
-                      surf_h(0)%qcsws(mm(0)) = surf_lsm_h%qcsws(m)
-                   IF ( ALLOCATED( surf_lsm_h%qisws ) )                                            &
-                      surf_h(0)%qisws(mm(0)) = surf_lsm_h%qisws(m)
-                   IF ( ALLOCATED( surf_lsm_h%qrsws ) )                                            &
-                      surf_h(0)%qrsws(mm(0)) = surf_lsm_h%qrsws(m)
-                   IF ( ALLOCATED( surf_lsm_h%ncsws ) )                                            &
-                      surf_h(0)%ncsws(mm(0)) = surf_lsm_h%ncsws(m)
-                   IF ( ALLOCATED( surf_lsm_h%nisws ) )                                            &
-                      surf_h(0)%nisws(mm(0)) = surf_lsm_h%nisws(m)
-                   IF ( ALLOCATED( surf_lsm_h%nrsws ) )                                            &
-                      surf_h(0)%nrsws(mm(0)) = surf_lsm_h%nrsws(m)
-                   IF ( ALLOCATED( surf_lsm_h%sasws ) )                                            &
-                     surf_h(0)%sasws(mm(0)) = surf_lsm_h%sasws(m)
-
-                   mm(0) = mm(0) + 1
+                   IF ( ALLOCATED( surf_lsm_h(l)%qcsws ) )                                            &
+                      surf_h(0)%qcsws(mm(0)) = surf_lsm_h(l)%qcsws(m)
+                   IF ( ALLOCATED( surf_lsm_h(l)%qisws ) )                                            &
+                      surf_h(0)%qisws(mm(0)) = surf_lsm_h(l)%qisws(m)
+                   IF ( ALLOCATED( surf_lsm_h(l)%qrsws ) )                                            &
+                      surf_h(0)%qrsws(mm(0)) = surf_lsm_h(l)%qrsws(m)
+                   IF ( ALLOCATED( surf_lsm_h(l)%ncsws ) )                                            &
+                      surf_h(0)%ncsws(mm(0)) = surf_lsm_h(l)%ncsws(m)
+                   IF ( ALLOCATED( surf_lsm_h(l)%nisws ) )                                            &
+                      surf_h(0)%nisws(mm(0)) = surf_lsm_h(l)%nisws(m)
+                   IF ( ALLOCATED( surf_lsm_h(l)%nrsws ) )                                            &
+                      surf_h(0)%nrsws(mm(0)) = surf_lsm_h(l)%nrsws(m)
+                   IF ( ALLOCATED( surf_lsm_h(l)%sasws ) )                                            &
+                     surf_h(0)%sasws(mm(0)) = surf_lsm_h(l)%sasws(m)
+
+                   mm(l) = mm(l) + 1
 
                 ENDDO
 
-                DO  m = surf_usm_h%start_index(j,i), surf_usm_h%end_index(j,i)
-                   IF ( ALLOCATED( surf_usm_h%us ) )                                               &
-                      surf_h(0)%us(mm(0)) = surf_usm_h%us(m)
-                   IF ( ALLOCATED( surf_usm_h%ts ) )                                               &
-                      surf_h(0)%ts(mm(0)) = surf_usm_h%ts(m)
-                   IF ( ALLOCATED( surf_usm_h%qs ) )                                               &
-                      surf_h(0)%qs(mm(0)) = surf_usm_h%qs(m)
-                   IF ( ALLOCATED( surf_usm_h%ss ) )                                               &
-                      surf_h(0)%ss(mm(0)) = surf_usm_h%ss(m)
-                   IF ( ALLOCATED( surf_usm_h%qcs ) )                                              &
-                      surf_h(0)%qcs(mm(0)) = surf_usm_h%qcs(m)
-                   IF ( ALLOCATED( surf_usm_h%ncs ) )                                              &
-                      surf_h(0)%ncs(mm(0)) = surf_usm_h%ncs(m)
-                   IF ( ALLOCATED( surf_usm_h%qis ) )                                              &
-                      surf_h(0)%qis(mm(0)) = surf_usm_h%qis(m)
-                   IF ( ALLOCATED( surf_usm_h%nis ) )                                              &
-                      surf_h(0)%nis(mm(0)) = surf_usm_h%nis(m)
-                   IF ( ALLOCATED( surf_usm_h%qrs ) )                                              &
-                      surf_h(0)%qrs(mm(0)) = surf_usm_h%qrs(m)
-                   IF ( ALLOCATED( surf_usm_h%nrs ) )                                              &
-                      surf_h(0)%nrs(mm(0)) = surf_usm_h%nrs(m)
-                   IF ( ALLOCATED( surf_usm_h%ol ) )                                               &
-                      surf_h(0)%ol(mm(0)) = surf_usm_h%ol(m)
-                   IF ( ALLOCATED( surf_usm_h%rib ) )                                              &
-                      surf_h(0)%rib(mm(0)) = surf_usm_h%rib(m)
-                   IF ( ALLOCATED( surf_usm_h%pt_surface ) )                                       &
-                      surf_h(l)%pt_surface(mm(l)) = surf_usm_h%pt_surface(m)
-                    IF ( ALLOCATED( surf_usm_h%q_surface ) )                                       &
-                      surf_h(l)%q_surface(mm(l)) = surf_usm_h%q_surface(m)
-                   IF ( ALLOCATED( surf_usm_h%vpt_surface ) )                                      &
-                      surf_h(l)%vpt_surface(mm(l)) = surf_usm_h%vpt_surface(m)
-                   IF ( ALLOCATED( surf_usm_h%usws ) )                                             &
-                      surf_h(0)%usws(mm(0)) = surf_usm_h%usws(m)
-                   IF ( ALLOCATED( surf_usm_h%vsws ) )                                             &
-                      surf_h(0)%vsws(mm(0)) = surf_usm_h%vsws(m)
-                   IF ( ALLOCATED( surf_usm_h%shf ) )                                              &
-                      surf_h(0)%shf(mm(0)) = surf_usm_h%shf(m)
-                   IF ( ALLOCATED( surf_usm_h%qsws ) )                                             &
-                      surf_h(0)%qsws(mm(0)) = surf_usm_h%qsws(m)
-                   IF ( ALLOCATED( surf_usm_h%ssws ) )                                             &
-                      surf_h(0)%ssws(mm(0)) = surf_usm_h%ssws(m)
-                   IF ( ALLOCATED( surf_usm_h%css ) )  THEN
+                DO  m = surf_usm_h(l)%start_index(j,i), surf_usm_h(l)%end_index(j,i)
+                   IF ( ALLOCATED( surf_usm_h(l)%us ) )                                               &
+                      surf_h(0)%us(mm(0)) = surf_usm_h(l)%us(m)
+                   IF ( ALLOCATED( surf_usm_h(l)%ts ) )                                               &
+                      surf_h(0)%ts(mm(0)) = surf_usm_h(l)%ts(m)
+                   IF ( ALLOCATED( surf_usm_h(l)%qs ) )                                               &
+                      surf_h(0)%qs(mm(0)) = surf_usm_h(l)%qs(m)
+                   IF ( ALLOCATED( surf_usm_h(l)%ss ) )                                               &
+                      surf_h(0)%ss(mm(0)) = surf_usm_h(l)%ss(m)
+                   IF ( ALLOCATED( surf_usm_h(l)%qcs ) )                                              &
+                      surf_h(0)%qcs(mm(0)) = surf_usm_h(l)%qcs(m)
+                   IF ( ALLOCATED( surf_usm_h(l)%ncs ) )                                              &
+                      surf_h(0)%ncs(mm(0)) = surf_usm_h(l)%ncs(m)
+                   IF ( ALLOCATED( surf_usm_h(l)%qis ) )                                              &
+                      surf_h(0)%qis(mm(0)) = surf_usm_h(l)%qis(m)
+                   IF ( ALLOCATED( surf_usm_h(l)%nis ) )                                              &
+                      surf_h(0)%nis(mm(0)) = surf_usm_h(l)%nis(m)
+                   IF ( ALLOCATED( surf_usm_h(l)%qrs ) )                                              &
+                      surf_h(0)%qrs(mm(0)) = surf_usm_h(l)%qrs(m)
+                   IF ( ALLOCATED( surf_usm_h(l)%nrs ) )                                              &
+                      surf_h(0)%nrs(mm(0)) = surf_usm_h(l)%nrs(m)
+                   IF ( ALLOCATED( surf_usm_h(l)%ol ) )                                               &
+                      surf_h(0)%ol(mm(0)) = surf_usm_h(l)%ol(m)
+                   IF ( ALLOCATED( surf_usm_h(l)%rib ) )                                              &
+                      surf_h(0)%rib(mm(0)) = surf_usm_h(l)%rib(m)
+                   IF ( ALLOCATED( surf_usm_h(l)%pt_surface ) )                                       &
+                      surf_h(l)%pt_surface(mm(l)) = surf_usm_h(l)%pt_surface(m)
+                    IF ( ALLOCATED( surf_usm_h(l)%q_surface ) )                                       &
+                      surf_h(l)%q_surface(mm(l)) = surf_usm_h(l)%q_surface(m)
+                   IF ( ALLOCATED( surf_usm_h(l)%vpt_surface ) )                                      &
+                      surf_h(l)%vpt_surface(mm(l)) = surf_usm_h(l)%vpt_surface(m)
+                   IF ( ALLOCATED( surf_usm_h(l)%usws ) )                                             &
+                      surf_h(0)%usws(mm(0)) = surf_usm_h(l)%usws(m)
+                   IF ( ALLOCATED( surf_usm_h(l)%vsws ) )                                             &
+                      surf_h(0)%vsws(mm(0)) = surf_usm_h(l)%vsws(m)
+                   IF ( ALLOCATED( surf_usm_h(l)%shf ) )                                              &
+                      surf_h(0)%shf(mm(0)) = surf_usm_h(l)%shf(m)
+                   IF ( ALLOCATED( surf_usm_h(l)%qsws ) )                                             &
+                      surf_h(0)%qsws(mm(0)) = surf_usm_h(l)%qsws(m)
+                   IF ( ALLOCATED( surf_usm_h(l)%ssws ) )                                             &
+                      surf_h(0)%ssws(mm(0)) = surf_usm_h(l)%ssws(m)
+                   IF ( ALLOCATED( surf_usm_h(l)%css ) )  THEN
                       DO lsp = 1, nvar
-                         surf_h(0)%css(lsp,mm(0)) = surf_usm_h%css(lsp,m)
+                         surf_h(0)%css(lsp,mm(0)) = surf_usm_h(l)%css(lsp,m)
                       ENDDO
                    ENDIF
-                   IF ( ALLOCATED( surf_usm_h%cssws ) )  THEN
+                   IF ( ALLOCATED( surf_usm_h(l)%cssws ) )  THEN
                       DO lsp = 1, nvar
-                         surf_h(0)%cssws(lsp,mm(0)) = surf_usm_h%cssws(lsp,m)
+                         surf_h(0)%cssws(lsp,mm(0)) = surf_usm_h(l)%cssws(lsp,m)
                       ENDDO
                    ENDIF
-                   IF ( ALLOCATED( surf_usm_h%qcsws ) )                                            &
-                      surf_h(0)%qcsws(mm(0)) = surf_usm_h%qcsws(m)
-                   IF ( ALLOCATED( surf_usm_h%qisws ) )                                            &
-                      surf_h(0)%qisws(mm(0)) = surf_usm_h%qisws(m)
-                   IF ( ALLOCATED( surf_usm_h%qrsws ) )                                            &
-                      surf_h(0)%qrsws(mm(0)) = surf_usm_h%qrsws(m)
-                   IF ( ALLOCATED( surf_usm_h%ncsws ) )                                            &
-                      surf_h(0)%ncsws(mm(0))   = surf_usm_h%ncsws(m)
-                   IF ( ALLOCATED( surf_usm_h%nrsws ) )                                            &
-                      surf_h(0)%nrsws(mm(0)) = surf_usm_h%nrsws(m)
-                   IF ( ALLOCATED( surf_usm_h%nisws ) )                                            &
-                      surf_h(0)%nisws(mm(0)) = surf_usm_h%nisws(m)
-                   IF ( ALLOCATED( surf_usm_h%sasws ) )                                            &
-                     surf_h(0)%sasws(mm(0)) = surf_usm_h%sasws(m)
-
-                   mm(0) = mm(0) + 1
+                   IF ( ALLOCATED( surf_usm_h(l)%qcsws ) )                                            &
+                      surf_h(0)%qcsws(mm(0)) = surf_usm_h(l)%qcsws(m)
+                   IF ( ALLOCATED( surf_usm_h(l)%qisws ) )                                            &
+                      surf_h(0)%qisws(mm(0)) = surf_usm_h(l)%qisws(m)
+                   IF ( ALLOCATED( surf_usm_h(l)%qrsws ) )                                            &
+                      surf_h(0)%qrsws(mm(0)) = surf_usm_h(l)%qrsws(m)
+                   IF ( ALLOCATED( surf_usm_h(l)%ncsws ) )                                            &
+                      surf_h(0)%ncsws(mm(0))   = surf_usm_h(l)%ncsws(m)
+                   IF ( ALLOCATED( surf_usm_h(l)%nrsws ) )                                            &
+                      surf_h(0)%nrsws(mm(0)) = surf_usm_h(l)%nrsws(m)
+                   IF ( ALLOCATED( surf_usm_h(l)%nisws ) )                                            &
+                      surf_h(0)%nisws(mm(0)) = surf_usm_h(l)%nisws(m)
+                   IF ( ALLOCATED( surf_usm_h(l)%sasws ) )                                            &
+                     surf_h(0)%sasws(mm(0)) = surf_usm_h(l)%sasws(m)
+
+                   mm(l) = mm(l) + 1
 
                 ENDDO
@@ -3280,9 +3315,9 @@
                 surf_h(l)%end_index(j,i) = surf_h(l)%end_index(j,i) + 1
              ENDDO
-             IF ( l == 0 )  THEN
-                DO  m = surf_lsm_h%start_index(j,i), surf_lsm_h%end_index(j,i)
+             IF ( l < 2 )  THEN
+                DO  m = surf_lsm_h(l)%start_index(j,i), surf_lsm_h(l)%end_index(j,i)
                    surf_h(l)%end_index(j,i) = surf_h(l)%end_index(j,i) + 1
                 ENDDO
-                DO  m = surf_usm_h%start_index(j,i), surf_usm_h%end_index(j,i)
+                DO  m = surf_usm_h(l)%start_index(j,i), surf_usm_h(l)%end_index(j,i)
                    surf_h(l)%end_index(j,i) = surf_h(l)%end_index(j,i) + 1
                 ENDDO
@@ -4977,8 +5012,11 @@
 !--          Determine type of surface element, i.e. default, natural, urban, at current grid point.
              surf_match_def  = surf_def_h(l)%end_index(jc,ic) >= surf_def_h(l)%start_index(jc,ic)
-             surf_match_lsm  = ( surf_lsm_h%end_index(jc,ic)  >= surf_lsm_h%start_index(jc,ic) )   &
-                                .AND.  l == 0
-             surf_match_usm  = ( surf_usm_h%end_index(jc,ic)  >= surf_usm_h%start_index(jc,ic) )   &
-                                 .AND.  l == 0
+             IF ( l < 2 ) THEN
+                surf_match_lsm  = surf_lsm_h(l)%end_index(jc,ic) >= surf_lsm_h(l)%start_index(jc,ic)
+                surf_match_usm  = surf_usm_h(l)%end_index(jc,ic) >= surf_usm_h(l)%start_index(jc,ic)
+             ELSE
+                surf_match_lsm  = .FALSE.
+                surf_match_usm  = .FALSE.
+             ENDIF
 !
 !--          Write restart data onto default-type surfaces if required.
@@ -5002,8 +5040,8 @@
 !--          surfaces at (j,i). An example would be bridges.
              IF ( surf_match_lsm )  THEN
-                mm = surf_lsm_h%start_index(jc,ic)
+                mm = surf_lsm_h(l)%start_index(jc,ic)
                 DO  m = surf_h(l)%start_index(j,i), surf_h(l)%end_index(j,i)
-                   IF ( surf_lsm_h%end_index(jc,ic) >= mm )                                        &
-                      CALL restore_surface_elements( surf_lsm_h, mm, surf_h(l), m )
+                   IF ( surf_lsm_h(l)%end_index(jc,ic) >= mm )                                        &
+                      CALL restore_surface_elements( surf_lsm_h(l), mm, surf_h(l), m )
                    mm = mm + 1
                 ENDDO
@@ -5012,8 +5050,8 @@
 !--          Same for urban-type surfaces
              IF ( surf_match_usm )  THEN
-                mm = surf_usm_h%start_index(jc,ic)
+                mm = surf_usm_h(l)%start_index(jc,ic)
                 DO  m = surf_h(l)%start_index(j,i), surf_h(l)%end_index(j,i)
-                   IF ( surf_usm_h%end_index(jc,ic) >= mm )                                        &
-                      CALL restore_surface_elements( surf_usm_h, mm, surf_h(l), m )
+                   IF ( surf_usm_h(l)%end_index(jc,ic) >= mm )                                        &
+                      CALL restore_surface_elements( surf_usm_h(l), mm, surf_h(l), m )
                    mm = mm + 1
                 ENDDO
@@ -5606,12 +5644,12 @@
     DO  i = nxl, nxr
        DO  j = nys, nyn
-          surf_match_lsm  = surf_lsm_h%end_index(j,i) >= surf_lsm_h%start_index(j,i)
-          surf_match_usm  = surf_usm_h%end_index(j,i) >= surf_usm_h%start_index(j,i)
+          surf_match_lsm  = surf_lsm_h(l)%end_index(j,i) >= surf_lsm_h(l)%start_index(j,i)
+          surf_match_usm  = surf_usm_h(l)%end_index(j,i) >= surf_usm_h(l)%start_index(j,i)
 
           IF ( surf_match_lsm )  THEN
-             mm = surf_lsm_h%start_index(j,i)
+             mm = surf_lsm_h(l)%start_index(j,i)
              DO  m = surf_h(0)%start_index(j,i), surf_h(0)%end_index(j,i)
-                IF ( surf_lsm_h%end_index(j,i) >= mm )                                             &
-                   CALL restore_surface_elements( surf_lsm_h, mm, surf_h(0), m )
+                IF ( surf_lsm_h(l)%end_index(j,i) >= mm )                                             &
+                   CALL restore_surface_elements( surf_lsm_h(l), mm, surf_h(0), m )
                 mm = mm + 1
              ENDDO
@@ -5619,8 +5657,8 @@
 
           IF ( surf_match_usm )  THEN
-             mm = surf_usm_h%start_index(j,i)
+             mm = surf_usm_h(l)%start_index(j,i)
              DO  m = surf_h(0)%start_index(j,i), surf_h(0)%end_index(j,i)
-                IF ( surf_usm_h%end_index(j,i) >= mm )                                             &
-                   CALL restore_surface_elements( surf_usm_h, mm, surf_h(0), m )
+                IF ( surf_usm_h(l)%end_index(j,i) >= mm )                                             &
+                   CALL restore_surface_elements( surf_usm_h(l), mm, surf_h(0), m )
                 mm = mm + 1
              ENDDO
@@ -5802,6 +5840,6 @@
 !
 !-- Horizontal surfaces
-    ns_h_on_file(0) = surf_def_h(0)%ns + surf_lsm_h%ns + surf_usm_h%ns
-    ns_h_on_file(1) = surf_def_h(1)%ns
+    ns_h_on_file(0) = surf_def_h(0)%ns + surf_lsm_h(0)%ns + surf_usm_h(0)%ns
+    ns_h_on_file(1) = surf_def_h(1)%ns + surf_lsm_h(1)%ns + surf_usm_h(1)%ns
     ns_h_on_file(2) = surf_def_h(2)%ns
 !
Index: palm/trunk/SOURCE/synthetic_turbulence_generator_mod.f90
===================================================================
--- palm/trunk/SOURCE/synthetic_turbulence_generator_mod.f90	(revision 4670)
+++ palm/trunk/SOURCE/synthetic_turbulence_generator_mod.f90	(revision 4671)
@@ -25,4 +25,7 @@
 ! -----------------
 ! $Id$
+! Implementation of downward facing USM and LSM surfaces
+!
+! 4647 2020-08-24 16:36:18Z suehring
 ! Change default value of synthetic turbulence adjustment as well as compute_velocity_seeds_local 
 ! By default, the random-seed computation is now distributed among several cores. Especially for 
@@ -2410,20 +2413,20 @@
        pt_surf_mean_l = pt_surf_mean_l  + pt(k,j,i)
     ENDDO
-    DO  m = 1, surf_lsm_h%ns
-       i = surf_lsm_h%i(m)
-       j = surf_lsm_h%j(m)
-       k = surf_lsm_h%k(m)
-       friction_vel_l = friction_vel_l  + surf_lsm_h%us(m)
-       shf_mean_l     = shf_mean_l      + surf_lsm_h%shf(m) * drho_air(k)
-       scale_l_l      = scale_l_l       + surf_lsm_h%ol(m)
+    DO  m = 1, surf_lsm_h(0)%ns
+       i = surf_lsm_h(0)%i(m)
+       j = surf_lsm_h(0)%j(m)
+       k = surf_lsm_h(0)%k(m)
+       friction_vel_l = friction_vel_l  + surf_lsm_h(0)%us(m)
+       shf_mean_l     = shf_mean_l      + surf_lsm_h(0)%shf(m) * drho_air(k)
+       scale_l_l      = scale_l_l       + surf_lsm_h(0)%ol(m)
        pt_surf_mean_l = pt_surf_mean_l  + pt(k,j,i)
     ENDDO
-    DO  m = 1, surf_usm_h%ns
-       i = surf_usm_h%i(m)
-       j = surf_usm_h%j(m)
-       k = surf_usm_h%k(m)
-       friction_vel_l = friction_vel_l  + surf_usm_h%us(m)
-       shf_mean_l     = shf_mean_l      + surf_usm_h%shf(m) * drho_air(k)
-       scale_l_l      = scale_l_l       + surf_usm_h%ol(m)
+    DO  m = 1, surf_usm_h(0)%ns
+       i = surf_usm_h(0)%i(m)
+       j = surf_usm_h(0)%j(m)
+       k = surf_usm_h(0)%k(m)
+       friction_vel_l = friction_vel_l  + surf_usm_h(0)%us(m)
+       shf_mean_l     = shf_mean_l      + surf_usm_h(0)%shf(m) * drho_air(k)
+       scale_l_l      = scale_l_l       + surf_usm_h(0)%ol(m)
        pt_surf_mean_l = pt_surf_mean_l  + pt(k,j,i)
     ENDDO
Index: palm/trunk/SOURCE/time_integration.f90
===================================================================
--- palm/trunk/SOURCE/time_integration.f90	(revision 4670)
+++ palm/trunk/SOURCE/time_integration.f90	(revision 4671)
@@ -25,4 +25,7 @@
 ! -----------------
 ! $Id$
+! Implementation of downward facing USM and LSM surfaces
+!
+! 4669 2020-09-09 13:43:47Z pavelkrc
 ! - Fix missing call of radiation after spinup
 ! - Fix calculation of force_radiation_call
@@ -339,5 +342,5 @@
 
     USE land_surface_model_mod,                                                                    &
-        ONLY:  lsm_boundary_condition, lsm_energy_balance, lsm_soil_model, skip_time_do_lsm
+        ONLY:  lsm_boundary_condition, lsm_energy_balance, skip_time_do_lsm
 
     USE lagrangian_particle_model_mod,                                                             &
@@ -423,6 +426,6 @@
 
     USE urban_surface_mod,                                                                         &
-        ONLY:  usm_boundary_condition, usm_material_heat_model, usm_material_model,                &
-               usm_surface_energy_balance, usm_green_heat_model
+        ONLY:  usm_boundary_condition,                                                             &
+               usm_energy_balance
 
     USE virtual_measurement_mod,                                                                   &
@@ -1108,24 +1111,5 @@
 
                 CALL cpu_log( log_point(54), 'land_surface', 'start' )
-!
-!--             Call for horizontal upward-facing surfaces
-                CALL lsm_energy_balance( .TRUE., -1 )
-                CALL lsm_soil_model( .TRUE., -1, .TRUE. )
-!
-!--             Call for northward-facing surfaces
-                CALL lsm_energy_balance( .FALSE., 0 )
-                CALL lsm_soil_model( .FALSE., 0, .TRUE. )
-!
-!--             Call for southward-facing surfaces
-                CALL lsm_energy_balance( .FALSE., 1 )
-                CALL lsm_soil_model( .FALSE., 1, .TRUE. )
-!
-!--             Call for eastward-facing surfaces
-                CALL lsm_energy_balance( .FALSE., 2 )
-                CALL lsm_soil_model( .FALSE., 2, .TRUE. )
-!
-!--             Call for westward-facing surfaces
-                CALL lsm_energy_balance( .FALSE., 3 )
-                CALL lsm_soil_model( .FALSE., 3, .TRUE. )
+                CALL lsm_energy_balance( .FALSE. )
 
 !
@@ -1143,10 +1127,5 @@
              IF (urban_surface) THEN
                 CALL cpu_log( log_point(74), 'urban_surface', 'start' )
-
-                CALL usm_surface_energy_balance( .FALSE. )
-                IF ( usm_material_model )  THEN
-                   CALL usm_green_heat_model
-                   CALL usm_material_heat_model ( .FALSE. )
-                ENDIF
+                CALL usm_energy_balance( .FALSE. )
 
 !
@@ -1655,12 +1634,12 @@
              CALL cpu_log( log_point(23), 'disturb_heatflux', 'stop' )
           ENDIF
-          IF ( surf_lsm_h%ns    >= 1 )  THEN
+          IF ( surf_lsm_h(0)%ns >= 1 )  THEN
              CALL cpu_log( log_point(23), 'disturb_heatflux', 'start' )
-             CALL disturb_heatflux( surf_lsm_h    )
+             CALL disturb_heatflux( surf_lsm_h(0) )
              CALL cpu_log( log_point(23), 'disturb_heatflux', 'stop' )
           ENDIF
-          IF ( surf_usm_h%ns    >= 1 )  THEN
+          IF ( surf_usm_h(0)%ns >= 1 )  THEN
              CALL cpu_log( log_point(23), 'disturb_heatflux', 'start' )
-             CALL disturb_heatflux( surf_usm_h    )
+             CALL disturb_heatflux( surf_usm_h(0) )
              CALL cpu_log( log_point(23), 'disturb_heatflux', 'stop' )
           ENDIF
